JUCE: PluginDescription Class Reference

JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | Public Attributes | List of all members
PluginDescription Class Reference
juce_audio_processors » processors

A small class to represent some facts about a particular type of plug-in. More...

`#include <juce_PluginDescription.h>`

## Public Member Functions
| PluginDescription ()=default
| PluginDescription (const PluginDescription &)=default
| PluginDescription (PluginDescription &&)=default
PluginDescription & | operator= (const PluginDescription &)=default
PluginDescription & | operator= (PluginDescription &&)=default
bool | isDuplicateOf (const PluginDescription &other) const noexcept
| Returns true if the two descriptions refer to the same plug-in.
bool | matchesIdentifierString (const String &identifierString) const
| Return true if this description is equivalent to another one which created the given identifier string.
String | createIdentifierString () const
| Returns a string that can be saved and used to uniquely identify the plugin again.
std::unique_ptr< XmlElement > | createXml () const
| Creates an XML object containing these details.
bool | loadFromXml (const XmlElement &xml)
| Reloads the info in this structure from an XML record that was previously saved with createXML().

## Public Attributes
String | name
| The name of the plug-in.
String | descriptiveName
| A more descriptive name for the plug-in.
String | pluginFormatName
| The plug-in format, e.g.
String | category
| A category, such as "Dynamics", "Reverbs", etc.
String | manufacturerName
| The manufacturer.
String | version
| The version.
String | fileOrIdentifier
| Either the file containing the plug-in module, or some other unique way of identifying it.
Time | lastFileModTime
| The last time the plug-in file was changed.
Time | lastInfoUpdateTime
| The last time that this information was updated.
int | deprecatedUid = 0
| Deprecated: New projects should use uniqueId instead.
int | uniqueId = 0
| A unique ID for the plug-in.
bool | isInstrument = false
| True if the plug-in identifies itself as a synthesiser.
int | numInputChannels = 0
| The number of inputs.
int | numOutputChannels = 0
| The number of outputs.
bool | hasSharedContainer = false
| True if the plug-in is part of a multi-type container, e.g.
bool | hasARAExtension = false
| True if the plug-in is ARA enabled and can supply a valid ARAFactoryWrapper.

## Detailed Description

A small class to represent some facts about a particular type of plug-in.

This class is for storing and managing the details about a plug-in without actually having to load an instance of it.

A KnownPluginList contains a list of PluginDescription objects.

See also
  KnownPluginList

## Constructor & Destructor Documentation

## ◆ PluginDescription() [1/3]

PluginDescription::PluginDescription | ( |  | ) |
| default

## ◆ PluginDescription() [2/3]

PluginDescription::PluginDescription | ( | const PluginDescription & |  | ) |
| default

## ◆ PluginDescription() [3/3]

PluginDescription::PluginDescription | ( | PluginDescription && |  | ) |
| default

## Member Function Documentation

## ◆ operator=() [1/2]

PluginDescription & PluginDescription::operator= | ( | const PluginDescription & |  | ) |
| default

## ◆ operator=() [2/2]

PluginDescription & PluginDescription::operator= | ( | PluginDescription && |  | ) |
| default

## ◆ isDuplicateOf()

bool PluginDescription::isDuplicateOf | ( | const PluginDescription & | other | ) | const
| noexcept

Returns true if the two descriptions refer to the same plug-in.

This isn't quite as simple as them just having the same file (because of shell plug-ins).

## ◆ matchesIdentifierString()

bool PluginDescription::matchesIdentifierString | ( | const String & | identifierString | ) | const

Return true if this description is equivalent to another one which created the given identifier string.

Note that this isn't quite as simple as them just calling createIdentifierString() and comparing the strings, because the identifiers can differ (thanks to shell plug-ins).

## ◆ createIdentifierString()

String PluginDescription::createIdentifierString | ( |  | ) | const

Returns a string that can be saved and used to uniquely identify the plugin again.

This contains less info than the XML encoding, and is independent of the plug-in's file location, so can be used to store a plug-in ID for use across different machines.

## ◆ createXml()

std::unique_ptr< XmlElement > PluginDescription::createXml | ( |  | ) | const

Creates an XML object containing these details.

See also
  loadFromXml

## ◆ loadFromXml()

bool PluginDescription::loadFromXml | ( | const XmlElement & | xml | ) |

Reloads the info in this structure from an XML record that was previously saved with createXML().

Returns true if the XML was a valid plug-in description.

## Member Data Documentation

## ◆ name

String PluginDescription::name

The name of the plug-in.

## ◆ descriptiveName

String PluginDescription::descriptiveName

A more descriptive name for the plug-in.

This may be the same as the 'name' field, but some plug-ins may provide an alternative name.

## ◆ pluginFormatName

String PluginDescription::pluginFormatName

The plug-in format, e.g.

"VST", "AudioUnit", etc.

## ◆ category

String PluginDescription::category

A category, such as "Dynamics", "Reverbs", etc.

## ◆ manufacturerName

String PluginDescription::manufacturerName

The manufacturer.

## ◆ version

String PluginDescription::version

The version.

This string doesn't have any particular format.

## ◆ fileOrIdentifier

String PluginDescription::fileOrIdentifier

Either the file containing the plug-in module, or some other unique way of identifying it.

E.g. for an AU, this would be an ID string that the component manager could use to retrieve the plug-in. For a VST, it's the file path.

## ◆ lastFileModTime

Time PluginDescription::lastFileModTime

The last time the plug-in file was changed.

This is handy when scanning for new or changed plug-ins.

## ◆ lastInfoUpdateTime

Time PluginDescription::lastInfoUpdateTime

The last time that this information was updated.

This would typically have been during a scan when this plugin was first tested or found to have changed.

## ◆ deprecatedUid

int PluginDescription::deprecatedUid = 0

Deprecated: New projects should use uniqueId instead.

A unique ID for the plug-in.

Note that this might not be unique between formats, e.g. a VST and some other format might actually have the same id.

See also
  createIdentifierString

## ◆ uniqueId

int PluginDescription::uniqueId = 0

A unique ID for the plug-in.

Note that this might not be unique between formats, e.g. a VST and some other format might actually have the same id.

The uniqueId field replaces the deprecatedUid field, and fixes an issue where VST3 plugins with matching FUIDs would generate different uid values depending on the platform. The deprecatedUid field is kept for backwards compatibility, allowing existing hosts to migrate from the old uid to the new uniqueId.

See also
  createIdentifierString

## ◆ isInstrument

bool PluginDescription::isInstrument = false

True if the plug-in identifies itself as a synthesiser.

## ◆ numInputChannels

int PluginDescription::numInputChannels = 0

The number of inputs.

## ◆ numOutputChannels

int PluginDescription::numOutputChannels = 0

The number of outputs.

## ◆ hasSharedContainer

bool PluginDescription::hasSharedContainer = false

True if the plug-in is part of a multi-type container, e.g.

a VST Shell.

## ◆ hasARAExtension

bool PluginDescription::hasARAExtension = false

True if the plug-in is ARA enabled and can supply a valid ARAFactoryWrapper.

The documentation for this class was generated from the following file:

- juce_PluginDescription.h